---
services:
  node_exporter:
    command: --path.rootfs /host
    image: prom/node-exporter:v1.8.2@sha256:4032c6d5bfd752342c3e631c2f1de93ba6b86c41db6b167b9a35372c139e7706
    pid: host
    restart: always
    volumes:
      - /:/host:ro,rslave
{% if config.grafana_cloud.enabled | default(false) %}
  alloy:
    command: run --server.http.listen-addr=0.0.0.0:12345 --storage.path=/var/lib/alloy/data /etc/alloy/config.alloy
    environment:
      - GC_API_TOKEN
      - GC_LOGS_ENDPOINT
      - GC_LOGS_USERNAME
      - GC_METRICS_ENDPOINT
      - GC_METRICS_USERNAME
    image: grafana/alloy:v1.4.3
    labels:
      - "traefik.docker.network=router_default"
      - "traefik.enable=true"
      - "traefik.http.routers.alloy.entrypoints=websecure"
      - "traefik.http.routers.alloy.middlewares=auth"
      - "traefik.http.routers.alloy.rule=Host(`alloy.${H2_DOMAIN}`)"
      - "traefik.http.routers.alloy.tls.certresolver=letsencrypt"
    ports:
      - 12345
    networks:
      - default
      - router
    restart: always
    volumes:
      - alloy:/var/lib/alloy/data
      - ./config.alloy:/etc/alloy/config.alloy:ro,Z
      - /run/docker.sock:/run/docker.sock
      - /var/log/journal:/var/log/journal:ro
{% else %}
  grafana:
    image: grafana/grafana:11.3.0@sha256:a0f881232a6fb71a0554a47d0fe2203b6888fe77f4cefb7ea62bed7eb54e13c3
    environment:
      - GF_INSTANCE_NAME=grafana.${H2_DOMAIN}
      - GF_SMTP_ENABLED=true
      - GF_SMTP_FROM_ADDRESS=grafana@${H2_DOMAIN}
      - GF_SMTP_HOST
      - GF_SMTP_PASSWORD
      - GF_SMTP_STARTTLS_POLICY=MandatoryStartTLS
      - GF_SMTP_USER
    labels:
      - "traefik.docker.network=router_default"
      - "traefik.enable=true"
      - "traefik.http.routers.monitoring.entrypoints=websecure"
      - "traefik.http.routers.monitoring.rule=Host(`grafana.${H2_DOMAIN}`)"
      - "traefik.http.routers.monitoring.tls.certresolver=letsencrypt"
    networks:
      - default
      - hunter2
      - router
    ports:
      - 127.0.0.1:3001:3000
    restart: always
    volumes:
      - grafana:/var/lib/grafana:Z
  prometheus:
    command:
      - "--config.file=/etc/prometheus/prometheus.yml"
      - "--storage.tsdb.path=/prometheus"
      - "--web.console.libraries=/usr/share/prometheus/console_libraries"
      - "--web.console.templates=/usr/share/prometheus/consoles"
      - "--web.enable-admin-api"
    image: prom/prometheus:v2.55.0@sha256:378f4e03703557d1c6419e6caccf922f96e6d88a530f7431d66a4c4f4b1000fe
    ports:
      - 127.0.0.1:9091:9090
    restart: always
    volumes:
      - ./prometheus.yml:/etc/prometheus/prometheus.yml:ro
      - prometheus:/prometheus:Z
{% endif %}

networks:
{% if not config.grafana_cloud.enabled | default(false) %}
  hunter2:
    name: hunter2_default
    external: true
{% endif %}
  router:
    name: router_default
    external: true

volumes:
{% if config.grafana_cloud.enabled | default(false) %}
  alloy: {}
{% else %}
  grafana: {}
  prometheus: {}
{% endif %}
